/**************************************************************
	SC02_bt.h  hardware setting and utility functions
				
						2015.7.17 M.Ustumi@ARCDEVICE

***************************************************************/

#ifndef SC02_BT_H
#define SC02_BT_H

#include"p30f4011.h"

// ̎
#define SC02

// NbN
//#define FOSC_7_3728MHz
#define FOSC_10MHz

#define M_PI 3.1415f
#define M_2PI 6.283f
#define DEGtoRAD 0.01745329252f 
#define RADtoDEG 57.29577951f
#define RADSECtoRPM 9.549296586 
#define RPMtoRADSEC 0.1047197551f

#define TRUE 1
#define FALSE 0

#define UCHAR	unsigned char
#define USHORT	unsigned short 
#define UINT	unsigned int 
#define ULONG	unsigned long

#define BYTE 	unsigned char 
#define WORD 	unsigned short 
#define DWORD	unsigned long 
#define BOOL	int

// szu

// LED ̐ݒ
#define TRIS_LED 	_TRISE8
#define LED 		_LATE8
#define LED_ON() 	_LATE8 = 0
#define LED_OFF() 	_LATE8 = 1

// ESPI
#define DIR_DE		_LATF4
#define TRIS_DIR_DE	_TRISF4
#define DIR_RE		_LATF5
#define TRIS_DIR_RE	_TRISF5
#define CS		PORTBbits.RB2
#define TRIS_CS   _TRISB2
#define SPI_SCK	_RF6

// USB
#define USB_RD	_LATE5					
#define USB_WR	_LATE4
#define TRIS_RD	TRISEbits.TRISE5
#define TRIS_WR	TRISEbits.TRISE4
#define TXE	PORTFbits.RF1
#define RXF	PORTFbits.RF0

// D0-D3	RD0-RD3
// D4-D7	RE0-RE7
inline void DB_SetDirIn( void );
inline void DB_SetDirOut( void );
inline BYTE DB_Input( void );
inline void DB_Output( BYTE b );

#define TRIS_D0_D3	TRISD
#define TRIS_D4_D7	TRISE
#define D0_D3_IN	PORTD	
#define D4_D7_IN	PORTE	
#define D0_D3_OUT	LATD	
#define D4_D7_OUT	LATE	

void UT_SetTimeout( float dt_s  );
void UT_StartTimeoutTimer( void );
#define UT_StopTimeoutTimer()	T2CONbits.TON = 0
#define UT_IsTimeout()	IFS0bits.T3IF
#define UT_ClearTimeout() IFS0bits.T3IF = 0

void UT_Wait_us( WORD us  );
void UT_Wait_ms( WORD ms );
void UT_Blink( WORD t );
void UT_ZeroMemory( void* pBuf, WORD wSize );

void FLASH_Erace_32dw( WORD wAddr );
void FLASH_Write_4dw( WORD wAddr, WORD* pwCode );
void FLASH_Read_dw( WORD wAddr, WORD* pwCode );

void EEP_Read( WORD wPage, WORD wOffset, WORD* pwBuf, WORD wSize );
void EEP_Write( WORD wPage, WORD wOffset, WORD* pwBuf, WORD wSize );

#endif
